/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentityMembership type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentityMembership{}

// IdentityMembership struct for IdentityMembership
type IdentityMembership struct {
	GroupId    *string        `json:"groupId,omitempty"`
	IdentityId *string        `json:"identityId,omitempty"`
	Comment    NullableString `json:"comment,omitempty"`
	Builtin    *bool          `json:"builtin,omitempty"`
}

// NewIdentityMembership instantiates a new IdentityMembership object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentityMembership() *IdentityMembership {
	this := IdentityMembership{}
	return &this
}

// NewIdentityMembershipWithDefaults instantiates a new IdentityMembership object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityMembershipWithDefaults() *IdentityMembership {
	this := IdentityMembership{}
	return &this
}

// GetGroupId returns the GroupId field value if set, zero value otherwise.
func (o *IdentityMembership) GetGroupId() string {
	if o == nil || IsNil(o.GroupId) {
		var ret string
		return ret
	}
	return *o.GroupId
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembership) GetGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.GroupId) {
		return nil, false
	}
	return o.GroupId, true
}

// HasGroupId returns a boolean if a field has been set.
func (o *IdentityMembership) HasGroupId() bool {
	if o != nil && !IsNil(o.GroupId) {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given string and assigns it to the GroupId field.
func (o *IdentityMembership) SetGroupId(v string) {
	o.GroupId = &v
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise.
func (o *IdentityMembership) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId) {
		var ret string
		return ret
	}
	return *o.IdentityId
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembership) GetIdentityIdOk() (*string, bool) {
	if o == nil || IsNil(o.IdentityId) {
		return nil, false
	}
	return o.IdentityId, true
}

// HasIdentityId returns a boolean if a field has been set.
func (o *IdentityMembership) HasIdentityId() bool {
	if o != nil && !IsNil(o.IdentityId) {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given string and assigns it to the IdentityId field.
func (o *IdentityMembership) SetIdentityId(v string) {
	o.IdentityId = &v
}

// GetComment returns the Comment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembership) GetComment() string {
	if o == nil || IsNil(o.Comment.Get()) {
		var ret string
		return ret
	}
	return *o.Comment.Get()
}

// GetCommentOk returns a tuple with the Comment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembership) GetCommentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Comment.Get(), o.Comment.IsSet()
}

// HasComment returns a boolean if a field has been set.
func (o *IdentityMembership) HasComment() bool {
	if o != nil && o.Comment.IsSet() {
		return true
	}

	return false
}

// SetComment gets a reference to the given NullableString and assigns it to the Comment field.
func (o *IdentityMembership) SetComment(v string) {
	o.Comment.Set(&v)
}

// SetCommentNil sets the value for Comment to be an explicit nil
func (o *IdentityMembership) SetCommentNil() {
	o.Comment.Set(nil)
}

// UnsetComment ensures that no value is present for Comment, not even an explicit nil
func (o *IdentityMembership) UnsetComment() {
	o.Comment.Unset()
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *IdentityMembership) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembership) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *IdentityMembership) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *IdentityMembership) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o IdentityMembership) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentityMembership) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.GroupId) {
		toSerialize["groupId"] = o.GroupId
	}
	if !IsNil(o.IdentityId) {
		toSerialize["identityId"] = o.IdentityId
	}
	if o.Comment.IsSet() {
		toSerialize["comment"] = o.Comment.Get()
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableIdentityMembership struct {
	value *IdentityMembership
	isSet bool
}

func (v NullableIdentityMembership) Get() *IdentityMembership {
	return v.value
}

func (v *NullableIdentityMembership) Set(val *IdentityMembership) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityMembership) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityMembership) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityMembership(val *IdentityMembership) *NullableIdentityMembership {
	return &NullableIdentityMembership{value: val, isSet: true}
}

func (v NullableIdentityMembership) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityMembership) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
